Trip to Saint Petersburg CodeForces - 1250C(线段树)

You are planning your trip to Saint Petersburg. After doing some calculations, you estimated that you will have to spend k rubles each day you stay in Saint Petersburg — you have to rent a flat, to eat at some local cafe, et cetera. So, if the day of your arrival is L, and the day of your departure is R, you will have to spend k(R−L+1) rubles in Saint Petersburg.

You don’t want to spend a lot of money on your trip, so you decided to work in Saint Petersburg during your trip. There are n available projects numbered from 1 to n, the i-th of them lasts from the day li to the day ri inclusive. If you choose to participate in the i-th project, then you have to stay and work in Saint Petersburg for the entire time this project lasts, but you get paid pi rubles for completing it.

Now you want to come up with an optimal trip plan: you have to choose the day of arrival L, the day of departure R and the set of projects S to participate in so that all the following conditions are met:

your trip lasts at least one day (formally, R≥L);
you stay in Saint Petersburg for the duration of every project you have chosen (formally, for each s∈S L≤ls and R≥rs);
your total profit is strictly positive and maximum possible (formally, you have to maximize the value of ∑s∈Sps−k(R−L+1), and this value should be positive).
You may assume that no matter how many projects you choose, you will still have time and ability to participate in all of them, even if they overlap.

Input
The first line contains two integers n and k (1≤n≤2⋅105, 1≤k≤1012) — the number of projects and the amount of money you have to spend during each day in Saint Petersburg, respectively.

Then n lines follow, each containing three integers li, ri, pi (1≤li≤ri≤2⋅105, 1≤pi≤1012) — the starting day of the i-th project, the ending day of the i-th project, and the amount of money you get paid if you choose to participate in it, respectively.

Output
If it is impossible to plan a trip with strictly positive profit, print the only integer 0.

Otherwise, print two lines. The first line should contain four integers p, L, R and m — the maximum profit you can get, the starting day of your trip, the ending day of your trip and the number of projects you choose to complete, respectively. The second line should contain m distinct integers s1, s2, …, sm — the projects you choose to complete, listed in arbitrary order. If there are multiple answers with maximum profit, print any of them.

Examples
Input
4 5
1 1 3
3 3 11
5 5 17
7 7 4
Output
13 3 5 2
3 2
Input
1 3
1 2 5
Output
0
Input
4 8
1 5 16
2 4 9
3 3 24
1 5 13
Output
22 1 5 4
3 2 1 4
思路:区间操作,大部分是线段树了。这个问题的难点在于我们如何求区间以及最值。
区间的两个端点,我们可以固定一个,然后线段树去求另一个。我们枚举右区间,也就是结束旅行的时间,对于每一个R,我们将[1,R]都减去k,这一步的操作是代表这一段时间的花费,通过这样操作,那么在来的那一天L,就减去了(R-L+1)*k。对于以R为右端点的区间,我们将[1,e[i].x]这一段区间都加上e[i].val(因为这一段任务必须是e[i].x开始的,因此不能在[e[i].x,e[i].y]区间加val),这一步操作是代表这一段时间所带来的的收益可以覆盖的区间。然后通过线段树查询[1,R]区间内最大值以及最大值的点(这里求得是旅行开始的时间L,旅行结束的时间为当前的R),不断的更新答案。
代码如下:

#include<bits/stdc++.h>
#define ll long long
#define Pll pair<ll,int> 
using namespace std;

const int maxx=2e5+100;
struct node{
	int l,r,id;
	ll lazy,_max;
}p[maxx<<2];
struct edge{
	int x,y,id;
	ll val;
	bool operator<(const edge &a)const{
		return y<a.y;
	}
}e[maxx];
int n;ll k;

inline void pushup(int cur)
{
	p[cur]._max=max(p[cur<<1]._max,p[cur<<1|1]._max);
	if(p[cur<<1]._max==p[cur]._max) p[cur].id=p[cur<<1].id;
	else p[cur].id=p[cur<<1|1].id;
}
inline void pushdown(int cur)
{
	if(p[cur].lazy)
	{
		p[cur<<1].lazy+=p[cur].lazy;
		p[cur<<1|1].lazy+=p[cur].lazy;
		p[cur<<1]._max+=p[cur].lazy;
		p[cur<<1|1]._max+=p[cur].lazy;
		p[cur].lazy=0;
	}
}
inline void build(int l,int r,int cur)
{
	p[cur].l=l;
	p[cur].r=r;
	p[cur].lazy=p[cur]._max=0;
	if(l==r)
	{
		p[cur].id=l;
		return ;
	}
	int mid=l+r>>1;
	build(l,mid,cur<<1);
	build(mid+1,r,cur<<1|1);
}
inline void update(int l,int r,ll v,int cur)
{
	int L=p[cur].l;
	int R=p[cur].r;
	if(l<=L&&R<=r)
	{
		p[cur].lazy+=v;
		p[cur]._max+=v;
		return ;
	}
	pushdown(cur);
	int mid=L+R>>1;
	if(r<=mid) update(l,r,v,cur<<1);
	else if(l>mid) update(l,r,v,cur<<1|1);
	else update(l,mid,v,cur<<1),update(mid+1,r,v,cur<<1|1);
	pushup(cur);
} 
inline Pll query(int l,int r,int cur)
{
	int L=p[cur].l;
	int R=p[cur].r;
	if(l<=L&&R<=r) return make_pair(p[cur]._max,p[cur].id);
	pushdown(cur);
	int mid=L+R>>1;
	if(r<=mid) return query(l,r,cur<<1);
	else if(l>mid) return query(l,r,cur<<1|1);
	else
	{
		Pll LL=query(l,mid,cur<<1);
		Pll RR=query(mid+1,r,cur<<1|1);
		if(LL.first>RR.first) return LL;
		else return RR;
	}
}
int main()
{
	scanf("%d%lld",&n,&k);
	for(int i=1;i<=n;i++) scanf("%d%d%lld",&e[i].x,&e[i].y,&e[i].val),e[i].id=i;
	sort(e+1,e+1+n);
	build(1,e[n].y,1);
	int j=1;
	ll ans=0;int L,R;
	for(int i=1;i<=e[n].y;i++)
	{
		update(1,i,-k,1);
		while(e[j].y==i)
		{
			update(1,e[j].x,e[j].val,1);
			++j;
		}
		Pll zz=query(1,i,1);
		if(zz.first>ans) ans=zz.first,L=zz.second,R=i;
	}
	if(ans==0) cout<<0<<endl;
	else
	{
		printf("%lld %d %d ",ans,L,R);
		vector<int> rr;
		for(int i=1;i<=n;i++) if(L<=e[i].x&&e[i].y<=R) rr.push_back(e[i].id);
		printf("%d\n",rr.size());
		for(int i=0;i<rr.size();i++) cout<<rr[i]<<" ";cout<<endl;
	}
	return 0;
}

很好的一道题目
努力加油a啊,(o)/~

  • 3
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 打赏
    打赏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

starlet_kiss

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值